=begin
 /****************************************************************
**
** Implementation CannonField class, Qt tutorial 8
**
****************************************************************/
=end
# For rubyQt
require "qt"
include Qt

class CannonField < QWidget
def initialize(parent=nil,name="")
   @angleChanged = RSignal.new("int")  # signal with int
   @forceChanged = RSignal.new("int")
   @ang = 45
   @f = 0
   @barrel_rect = QRect.new(33,-4, 15, 8)
   @bcolor = QColor.new(0,0,0)
   catchEvent
end

def angleChanged
   @angleChanged
end
def forceChanged
   @forceChanged
end

def setAngle degrees #slot
   if degrees < 5
      degrees = 5
   elsif degrees > 70
      degrees = 70
   elsif degrees == @ang
      return
   end
   @ang = degrees
   repaintQRect(cannonRect,false)
   angleChanged.send_int(@ang)
end

def setForce newton
   if newton < 0
      newton = 0
   elsif @f == newton
      return
   end
   @f = newton
   forceChanged.send_int(@f)
end

def paintEvent ev
    updateR = ev.rect
    p = QPainter.new(self)
    if (updateR.intersects( cannonRect ))
        paintCannon( p )
    end
    p.end
end

def paintCannon p
   cr = cannonRect
   pix = QPixmap.new(QSize.new(cr.width,cr.height))
   pix.fill(@bcolor)
   tmp = QPainter.new(pix)
   brush = QBrush.new(QColor.new(0,0,255))
   pen = QPen.new( QColor.new(255,255,255))
   pen.setStyle(NoPen)

   tmp.setBrush(brush)
   tmp.setPen(pen)

   tmp.translate(0, pix.height - 1)
   tmp.drawPie( -35,-35,70,70,0,90*16)
   tmp.rotate( - @ang )
   tmp.drawRect( @barrel_rect.x, @barrel_rect.y,
        @barrel_rect.width, @barrel_rect.height)
   tmp.end

   p.drawPixmap( cr.x,cr.y,pix)
end

def cannonRect
    r = QRect.new(0, 0, 50, 50)
    r.moveBottomLeft(QPoint.new(0,self.height))
    r
end
def  setBackgroundColor qcolor
   @bcolor = qcolor
   super
end
end
