=begin
/****************************************************************
**
** Definition of LCDRange class, Qt tutorial 8
**
****************************************************************/
=end
require "qt"
include Qt

class LCDRange < QWidget
def initialize(parent=nil,name="")

   @lcd = QLCDNumber.new( 2, self, "lcd"  )
   @lcd.move(0,0)
   @sBar = QScrollBar.new( 0, 99,		       	#// range
			   1, 10, 			#// line/page steps
			   0, 				#// inital value
			   QScrollBar::Horizontal, 	#// orientation
                           self, "scrollbar" )
   QObject::connect(@sBar,QSIGNAL("valueChanged(int)"),
      @lcd,QSLOT("display(int)"))
# for debug
#   QRObject::connect_rslot(@sBar,QSIGNAL("valueChanged(int)"),
#      self,"printInt")
   @valueChanged = RSignal.new("int")
# in Original,
#  connect( sBar, SIGNAL(valueChanged(int)), SIGNAL(valueChanged(int)) );
# I don't like to imprement ruby SIGNAL to ruby SIGNAL method!
   QRObject::connect_rslot(@sBar,QSIGNAL("valueChanged(int)"),
      self,"sendValueChanged")
   catchEvent

end
def sendValueChanged(int)  # Slot
   @valueChanged.send_int(int)
end
def value
   @sBar.value
end
def setValue(value)
   @sBar.setValue(value)
end
def setRange(minVal, maxVal)
   if(minVal < 0 || maxVal > 99 || minVal > maxVal)
      print ("LCDRange::setRange(#{minVal},#{maxVal})\n" +
               "\tRange must be 0..99\n" +
               "\tand minVal must not be greater than maxVal" )
      return
   end
   @sBar.setRange(minVal, maxVal)
end

def resizeEvent ev
   @sBar.setGeometry(0, height - 16, width, 16)
   @lcd.resize(width,@sBar.y - 5)
end
def sbar
   @sBar
end
def printInt int
   print "#{int}\n"
end
end
