=begin
/****************************************************************
**
** Definition of LCDRange class, Qt tutorial 8
**
****************************************************************/
=end
require "qt"
include Qt

class LCDRange < QWidget
def initialize (parent=nil, name="")
   s = name
   @lcd = QLCDNumber.new( 2, self, "lcd"  )
   @lcd.move(0,0)
   @sBar = QScrollBar.new( 0, 99,		       	#// range
			   1, 10, 			#// line/page steps
			   0, 				#// inital value
			   QScrollBar::Horizontal, 	#// orientation
                           self, "scrollbar" )
   @label = QLabel.new(s,self,"label")
   @label.setAlignment(Qt::AlignCenter)
   Qt::connect(@sBar,QSIGNAL("valueChanged(int)"),
       @lcd,QSLOT("display(int)"))
   @valueChanged = RSignal.new("int")
   Qt::connect( @sBar, QSIGNAL("valueChanged(int)"),
      @valueChanged )
   setText(s)
   catchEvent

end
def valueChanged
   @valueChanged
end
def sendValueChanged(int)  # Slot
   @valueChanged.send_int(int)
end
def value
   @sBar.value
end
def setValue(value)
   @sBar.setValue(value)
end
def text
   return label.text
end

def setRange(minVal, maxVal)
   if(minVal < 0 or maxVal > 99 or minVal > maxVal)
      print ("LCDRange::setRange(#{minVal},#{maxVal})\n" +
               "\tRange must be 0..99\n" +
               "\tand minVal must not be greater than maxVal" )
      return
   end
   @sBar.setRange(minVal, maxVal)
end
def setText s
   @label.setText(s)
end
def resizeEvent ev
   @lcd.resize(width,height - 41 - 5)
   @sBar.setGeometry(0, @lcd.height + 5, width, 16)
   @label.setGeometry(0, @lcd.height + 16 + 5, width, 20)

end
end
