#!/usr/local/bin/ruby
=begin
/****************************************************************
**
** Qt tutorial 8
**
****************************************************************/
=end
# For rubyQt

require "qt"
include Qt

require "lcdrange"
require "cannon"

class MyWidget < QWidget
def initialize
   setMinimumSize(500,355)
   @quit = QPushButton.new("Quit",self,"quit")
   @quit.setGeometry(10,10,75,30)
   @quit.setFont(  QFont.new( "Times", 18, QFont::Bold ) )
   QObject::connect(@quit,QSIGNAL("clicked()"),QApplication::qApp,
      QSLOT("quit()"))

   @angle = LCDRange.new(self,"angle")
   @angle.setRange(5,70)
   @angle.setGeometry(10,@quit.y + @quit.height + 10, 75, 130)

   @cannonField = CannonField.new(self,"cannonField")
   @cannonField.move(@angle.x + @angle.width + 10, @angle.y)
   @cannonField.setBackgroundColor( QColor.new(250,250,200))

   Qt::connect(@angle.sbar,QSIGNAL("valueChanged(int)"),@cannonField,"setAngle")
   Qt::connect(@cannonField.angleChanged,@angle,"setValue")
   @angle.setValue(60)
   catchEvent
end

def resizeEvent ev
   @cannonField.resize(width - @cannonField.x - 10,
      height - @cannonField.y - 20)
end
def dummy int
   print int
end
end

a = QApplication.new([$0] + ARGV)
w = MyWidget.new
a.setMainWidget(w)
w.show
a.exec

