=begin
/****************************************************************************
** $Id: cursor.cpp,v 2.3 1998/06/16 11:39:32 warwick Exp $
**
** Copyright (C) 1992-1998 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/
=end

require "qt"
include Qt

#// cb_bits and cm_bits were generated by X bitmap program.

Cb_width  = 32
Cb_height = 32
#// cursor bitmap


#//
#// The CursorView contains many labels with different cursors.
#//
class Cursor
def initialize cursor, name
   @qcursor = cursor
   @name = name
end
def cursor
   @qcursor
end
def name
   @name
end
end

class CursorView < QWidget		#// cursor view
#//
#// Constructs a cursor view.
#//

def initialize			#// construct view


     list = [
	Cursor.new(QCursor.new(ArrowCursor),	"arrowCursor"),
	Cursor.new(QCursor.new(UpArrowCursor),	"upArrowCursor" ),
	Cursor.new(QCursor.new(CrossCursor),	"crossCursor" ),
	Cursor.new(QCursor.new(WaitCursor),	"waitCursor" ),
	Cursor.new(QCursor.new(IbeamCursor),	"ibeamCursor" ),
	Cursor.new(QCursor.new(SizeVerCursor),	"sizeVerCursor" ),
	Cursor.new(QCursor.new(SizeHorCursor),	"sizeHorCursor" ),
	Cursor.new(QCursor.new(SizeBDiagCursor),	"sizeBDiagCursor" ),
	Cursor.new(QCursor.new(SizeFDiagCursor),	"sizeFDiagCursor" ),
	Cursor.new(QCursor.new(SizeAllCursor),	"sizeAllCursor" ),
	Cursor.new(nil,				"") ];

    setCaption( "CursorView" );			#// set window caption

    i=0;
    for y in 0..1 			#// create 10 small labels
	for x in 0..4
	    label = QLabel.new("", self );
	    label.setCursor( list[i].cursor );
	    label.setText( list[i].name );
	    label.setAlignment( AlignCenter );
	    label.setFrameStyle( QFrame::Box | QFrame::Raised );
	    label.setGeometry( 10+x*110, 10+y*50, 100, 40 );
	    i = i+1;
	end
    end
    @cb = QBitmap.new("cb.xbm");
    @cm = QBitmap.new("cm.xbm");
    @custom = QCursor.new( @cb, @cm );			#// create bitmap cursor

    label = QLabel.new("", self );			#// create the big label
    label.setCursor( @custom );
    label.setText( "Custom bitmap cursor" );
    label.setAlignment( AlignCenter );
    label.setFrameStyle( QFrame::Box | QFrame::Sunken );
    label.setGeometry( 10, 110, 540, 40 );
    resize( 20+5*110, 20+3*50 );
end

end

#//
#// Create and display a CursorView.
#//

    a = QApplication.new( [$0] + ARGV );		#// application object
    v = CursorView.new;				#// cursor view
    a.setMainWidget( v );
    v.show();
    a.exec();

